Use value of ADO recordset to make points in catia vba

124 Views Asked by At

I have an ADO Recordset the has numbers in an array (lots of rows and 3 columns) from a text file. I have been trying to each value at a record to form points in a Part in CATIA but it refuses to work. It reads the numbers as a string not integers.. so for instance i have the file as;

**coordinates.txt**
70      60       30
20      30       40 
50      12       33

so when you try to retrieve the first value(70) for instance, by using

Value= rsTest.GetRow

value1= Value(0,0)

so instead of 70 it takes the whole line as a string therefore showing value1= "70 60 30" It also does not read the second and thoird columns as seperate fields but all together with column 1 (meaning number of fields = 1 instead of 3)

The full code is given below;

Sub LoadFile()
Dim connCSV As New ADODB.Connection
Dim rsTest As New ADODB.Recordset
Dim adcomm As New ADODB.Command
Dim path As String
Dim Value As Variant
path = "C:\Users\hadiza\Documents\MATLAB\"
      'This is connection for a text file without Header

connCSV.Open "Provider=Microsoft.Jet.OLEDB.4.0;" & _
          "Data Source=" & path & ";" & _
          "Extended Properties=""text;HDR=YES;FMT=Delimited"""

   rsTest.Open "Select * From coordinates.txt", _
       connCSV, adOpenStatic, adLockReadOnly, adCmdText

       'Get CATIA DOCUMENT
Dim partDocument1 As PartDocument
Set partDocument1 = CATIA.ActiveDocument

Dim part1 As Part
Set part1 = partDocument1.Part

Dim hybridShapeFactory1 As HybridShapeFactory
Set hybridShapeFactory1 = part1.HybridShapeFactory

'Loop through points

  For i = 0 To (rsTest.RecordCount)
  rsTest.MoveFirst
 Value = rsTest.GetRows
     value1 = Value(0, i)
     value2 = Value(1, i)
     value3 = Value(2, i)
      Dim hybridShapePointCoord1 As HybridShapePointCoord
Set hybridShapePointCoord1 = hybridShapeFactory1.AddNewPointCoord(value1, value2, value3)

Dim bodies1 As Bodies
Set bodies1 = part1.Bodies

Dim body1 As Body
Set body1 = bodies1.Item("PartBody")

body1.InsertHybridShape hybridShapePointCoord1

part1.InWorkObject = hybridShapePointCoord1

part1.Update
Next
 ' MsgBox ("The number of records is: " & i)


rsTest.Close
connCSV.Close
End Sub
1

There are 1 best solutions below

0
On

Thank you all for your reply, I have been able to answer this question at long last. There really wasn't any problem with the code as i later found out. It was actually from the file as it had too empty spaces within it and all i had to do was delete them..